<script context="module">
	export const prerender = false;
</script>

<script>
	import Map from '$lib/leaflet';
	import { events } from '$lib/historicStore';
	import Row from '$lib/Events/Row.svelte';
	import { data as region } from '../../../geojson/regions-avant-redecoupage-2015';

	$: page = 0;

	$: id = 0;

	$: selected = {
		type: 'FeatureCollection',
		features: [].concat(
			...getEvent()
				.map((event) => {
					if (event.id === id) {
						return region.features.filter(({ properties: { code } }) => {
							return event.localisation.split(',').includes(code);
						});
					}
				})
				.filter(Boolean)
		)
	};

	$: geojson = {
		type: 'FeatureCollection',
		features: [].concat(
			...getEvent().map((event) =>
				region.features.filter(({ properties: { code } }) =>
					event.localisation.split(',').includes(code)
				)
			)
		)
	};

	$: options = {
		geojson: {
			general: geojson,
			selected: selected
		}
	};

	const NOMBRE_LINE = 10;

	$: getEvent = () => {
		return $events
			.filter((event) => event.nom)
			.slice(page * NOMBRE_LINE, page * NOMBRE_LINE + NOMBRE_LINE);
	};

	const hightlightMarker = (event) => {
		id = event.id;
	};
</script>

<h1 class="text-2xl font-semibold text-gray-900">HistorIC</h1>
<div class="flex w-full justify-end relative md:space-x-4">
	<div class="lg:w-1/3 lg:flex lg:sticky hidden">
		<div class="map w-full">
			{#key options}
				<Map {options} />
			{/key}
		</div>
	</div>
	<div class="lg:w-2/3 col-span-2 col-start-2 w-full">
		<div class="flex flex-col space-y-2">
			{#each getEvent(0) as event}
				<Row {event} on:enter={() => hightlightMarker(event)} />
			{:else}
				<p>No Event</p>
			{/each}
		</div>
		<div class="flex justify-around">
			<button on:click={() => page > 0 && page--} class="block text-blue-600">Precedent</button>
			<button on:click={() => page++} class="block text-blue-600">Suivant</button>
		</div>
	</div>
</div>

<style>
	.map {
		height: 600px;
	}
</style>
